
Summary: A PDF file viewer for the X Window System
Name: xpdf
Version: 3.03
Release: 1.ru
License: GPLv2
Epoch: 1
Url: http://www.foolabs.com/xpdf/
Group: Applications/Publishing

# There are some troublesome files named vms_*. We pull them out of the 
# tarball since we're not even using them on Linux.
Source0: ftp://ftp.foolabs.com/pub/xpdf/%{name}-%{version}.tar.gz
#Source0: %{name}-%{version}-novms.tar.gz
# We have to pull the CMap files out due to non-free license.
# Source3: ftp://ftp.foolabs.com/pub/xpdf/xpdf-chinese-simplified-2004-jul-27.tar.gz
Source3: xpdf-chinese-simplified-2004-jul-27-NOCMAP.tar.gz
# Source4: ftp://ftp.foolabs.com/pub/xpdf/xpdf-chinese-traditional-2004-jul-27.tar.gz
Source4: xpdf-chinese-traditional-2004-jul-27-NOCMAP.tar.gz
# Source5: ftp://ftp.foolabs.com/pub/xpdf/xpdf-japanese-2004-jul-27.tar.gz
Source5: xpdf-japanese-2004-jul-27-NOCMAP.tar.gz
# Source6: ftp://ftp.foolabs.com/pub/xpdf/xpdf-korean-2005-jul-07.tar.gz
Source6: xpdf-korean-2005-jul-07-NOCMAP.tar.gz
# cyrillic and thai don't have CMap files to worry about.
Source7: ftp://ftp.foolabs.com/pub/xpdf/xpdf-cyrillic-2003-jun-28.tar.gz
Source8: ftp://ftp.foolabs.com/pub/xpdf/xpdf-thai-2002-jan-16.tar.gz
Source10: xpdf.desktop
Source11: xpdf.png
Source12: ftp://ftp.foolabs.com/pub/xpdf/xpdf-arabic-2003-feb-16.tar.gz
Source13: ftp://ftp.foolabs.com/pub/xpdf/xpdf-greek-2003-jun-28.tar.gz
Source14: ftp://ftp.foolabs.com/pub/xpdf/xpdf-hebrew-2003-feb-16.tar.gz
Source15: ftp://ftp.foolabs.com/pub/xpdf/xpdf-latin2-2002-oct-22.tar.gz
Source16: ftp://ftp.foolabs.com/pub/xpdf/xpdf-turkish-2002-apr-10.tar.gz

#Patch0: xpdf-3.01-redhat-new.patch
#Patch3: xpdf-2.02-ext.patch
#Patch6: xpdf-3.00-core.patch
#Patch7: xpdf-3.00-xfont.patch
#Patch9: xpdf-3.00-papersize.patch
#Patch10: xpdf-3.00-gcc4.patch
#Patch11: xpdf-3.02-crash.patch
#Patch12: xpdf-3.00-64bit.patch
# Patch13: xpdf-3.01-resize.patch
# Patch14: xpdf-3.01-freetype-internals.patch
#Patch15: xpdf-3.01-nocmap.patch
#Patch16: xpdf-3.02-fontlist.patch
# Patch17: xpdf-3.02-x86_64-fix.patch
# Patch18: xpdf-3.02-mousebuttons.patch
#Patch19: xpdf-3.02-additionalzoom.patch
# Patch20: xpdf-3.02-mousebuttons_view.patch

# Security patches
#Patch100: xpdf-3.02pl1.patch
#Patch101: ftp://ftp.foolabs.com/pub/xpdf/xpdf-3.02pl2.patch
#Patch102: ftp://ftp.foolabs.com/pub/xpdf/xpdf-3.02pl3.patch
#Patch103: ftp://ftp.foolabs.com/pub/xpdf/xpdf-3.02pl4.patch

# Debian patches
#Patch200: 02_permissions.dpatch
#Patch201: 10_add_accelerators.dpatch
# Fix crash with ctrl-W in full screen mode
#Patch202: fix-437725.dpatch
# Proper stream encoding on 64bit platforms
#Patch203: fix-444648.dpatch
# Fix segfault in image handling
#Patch204: fix-462544.dpatch
# Fix crash with "g" in full screen mode
#Patch205: fix-479467.dpatch

Requires: urw-fonts
Requires: xdg-utils
Requires: poppler-utils
Requires: xorg-x11-fonts-ISO8859-1-75dpi
Requires: xorg-x11-fonts-ISO8859-1-100dpi

# BuildRequires: lesstif-devel
# RHEL 5 uses openmotif
BuildRequires: openmotif-devel
BuildRequires: freetype-devel >= 2.1.7
BuildRequires: desktop-file-utils
BuildRequires: t1lib-devel
BuildRequires: libpaper-devel

Provides:  %{name}-chinese-simplified = %{version}-%{release}
Obsoletes: %{name}-chinese-simplified
Provides:  %{name}-chinese-traditional = %{version}-%{release}
Obsoletes: %{name}-chinese-traditional
Provides:  %{name}-korean = %{version}-%{release}
Obsoletes: %{name}-korean
Provides:  %{name}-japanese = %{version}-%{release}
Obsoletes: %{name}-japanese

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
Xpdf is an X Window System based viewer for Portable Document Format
(PDF) files. Xpdf is a small and efficient program which uses
standard X fonts.

%prep
%setup -q -a 3 -a 4 -a 5 -a 6 -a 7 -a 8 -a 12 -a 13 -a 14 -a 15 -a 16
#%patch0 -p1
#%patch3 -p1 -b .ext
#%patch6 -p1 -b .core
#%patch7 -p1 -b .fonts
#%patch9 -p1 -b .papersize
#%patch10 -p1 -b .gcc4
#%patch11 -p1 -b .crash
#%patch12 -p1 -b .alloc
# Upstreamed
#%%patch13 -p1 -b .resize
#%%patch14 -p1 -b .freetype-internals
#%patch15 -p1
#%patch16 -p1 -b .fontlist
# %patch17 -p1
# %patch18 -p1
#%patch19 -p1
# %patch20 -p1

# security patches
#%patch100 -p1 -b .security
#%patch101 -p1 -b .security2
#%patch102 -p1 -b .security3
#%patch103 -p1 -b .security4

# debian patches
#%patch200 -p1 -b .permissions
#%patch201 -p1 -b .accelerators
#%patch202 -p1 -b .fullscreen-crashfix
#%patch203 -p1 -b .64bit-stream
#%patch204 -p1 -b .segfaultfix
#%patch205 -p1 -b .fullscreen-crashfix2

%build
find -name "*orig" | xargs rm -f

# This may seem pointless, but in the unlikely event that _sysconfdir != /etc ...
for file in doc/*.1 doc/*.5 xpdf-*/README; do
  sed -i -e 's:/etc/xpdfrc:%{_sysconfdir}/xpdfrc:g' $file
done
# Same action for _datadir.
for file in xpdf-*/README xpdf-*/add-to-xpdfrc; do
  sed -i -e 's:/usr/share/:%{_datadir}/:g' $file
  sed -i -e 's:/usr/local/share/:%{_datadir}/:g' $file
done

%configure \
   --enable-multithreaded \
   --enable-wordlist \
   --with-x \
   --with-gzip \
   --enable-opi \
   --with-appdef-dir=%{_datadir}/X11/app-defaults/ \
   --without-Xp-library \
   --with-t1-library \
   --with-freetype2-library=%{_libdir} \
   --with-freetype2-includes=%{_includedir}/freetype2

make %{?_smp_mflags}
make xpdf %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_datadir}/xpdf/arabic \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/chinese-simplified \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/chinese-traditional \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/cyrillic \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/greek \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/hebrew \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/japanese \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/korean \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/latin2 \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/thai \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/turkish \
         $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps

make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications/
desktop-file-install --vendor "fedora"                  \
        --dir $RPM_BUILD_ROOT%{_datadir}/applications   \
        --add-category X-Fedora                         \
        %{SOURCE10}
install -m 0644 %{SOURCE11} $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/xpdf.png

cp -pr xpdf-arabic/* $RPM_BUILD_ROOT%{_datadir}/xpdf/arabic/
cp -pr xpdf-chinese-simplified/* $RPM_BUILD_ROOT%{_datadir}/xpdf/chinese-simplified/
cp -pr xpdf-chinese-traditional/* $RPM_BUILD_ROOT%{_datadir}/xpdf/chinese-traditional/
cp -pr xpdf-cyrillic/* $RPM_BUILD_ROOT%{_datadir}/xpdf/cyrillic/
cp -pr xpdf-greek/* $RPM_BUILD_ROOT%{_datadir}/xpdf/greek/
cp -pr xpdf-hebrew/* $RPM_BUILD_ROOT%{_datadir}/xpdf/hebrew/
cp -pr xpdf-japanese/* $RPM_BUILD_ROOT%{_datadir}/xpdf/japanese/
cp -pr xpdf-korean/* $RPM_BUILD_ROOT%{_datadir}/xpdf/korean/
cp -pr xpdf-latin2/* $RPM_BUILD_ROOT%{_datadir}/xpdf/latin2/
cp -pr xpdf-thai/* $RPM_BUILD_ROOT%{_datadir}/xpdf/thai/
cp -pr xpdf-turkish/* $RPM_BUILD_ROOT%{_datadir}/xpdf/turkish/

# poppler provides all utilities now
# http://bugzilla.redhat.com/bugzillA/SHow_bug.cgi?id=177446
# https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=219032
rm $RPM_BUILD_ROOT%{_bindir}/pdffonts
rm $RPM_BUILD_ROOT%{_bindir}/pdfimages
rm $RPM_BUILD_ROOT%{_bindir}/pdfinfo
rm $RPM_BUILD_ROOT%{_bindir}/pdftops
rm $RPM_BUILD_ROOT%{_bindir}/pdftotext
rm $RPM_BUILD_ROOT%{_bindir}/pdftoppm

rm $RPM_BUILD_ROOT%{_mandir}/man1/pdffonts.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdfimages.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdfinfo.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdftops.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdftotext.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdftoppm.1*

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/xpdf/
for i in arabic chinese-simplified chinese-traditional cyrillic greek hebrew japanese korean latin2 thai turkish; do
     mv $RPM_BUILD_ROOT%{_datadir}/%{name}/$i/README README.$i
     mv $RPM_BUILD_ROOT%{_datadir}/%{name}/$i/add-to-xpdfrc $RPM_BUILD_ROOT%{_sysconfdir}/xpdf/add-to-xpdfrc.$i
done

# xpdfrc cleanup
sed -i -e 's:/usr/local/share/:%{_datadir}/:g' $RPM_BUILD_ROOT%{_sysconfdir}/xpdfrc

# CJK are already in the file
for i in arabic cyrillic greek hebrew latin2 thai turkish; do
    echo "# $i" >> $RPM_BUILD_ROOT%{_sysconfdir}/xpdfrc
    echo "include %{_sysconfdir}/xpdf/add-to-xpdfrc.$i" >> $RPM_BUILD_ROOT%{_sysconfdir}/xpdfrc
done

%clean
rm -rf $RPM_BUILD_ROOT

%post
touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
update-desktop-database &> /dev/null ||:

%postun
touch --no-create %{_datadir}/icons/hicolor || :
%{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
update-desktop-database &> /dev/null ||:

%files
%defattr(-,root,root)
%doc CHANGES README README.*
%{_bindir}/xpdf
%{_mandir}/man?/xpdf*
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdfrc
%dir %{_sysconfdir}/xpdf
%lang(ar) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.arabic
%lang(zh_CN) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.chinese-simplified
%lang(zh_TW) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.chinese-traditional
%lang(el) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.greek
%lang(iw) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.hebrew
%lang(ja) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.japanese
%lang(ko) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.korean
%lang(th) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.thai
%lang(tr) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.turkish

# cyrillic and latin2 are not langs, many languages are cyrillic/latin2
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.cyrillic
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.latin2
%{_datadir}/icons/hicolor/48x48/apps/xpdf.png
%dir %{_datadir}/xpdf
%{_datadir}/applications/*
%lang(ar) %{_datadir}/xpdf/arabic
%lang(zh_CN) %{_datadir}/xpdf/chinese-simplified
%lang(zh_TW) %{_datadir}/xpdf/chinese-traditional
%lang(el) %{_datadir}/xpdf/greek
%lang(iw) %{_datadir}/xpdf/hebrew
%lang(ja) %{_datadir}/xpdf/japanese
%lang(ko) %{_datadir}/xpdf/korean
%lang(th) %{_datadir}/xpdf/thai
%lang(tr) %{_datadir}/xpdf/turkish
%{_datadir}/xpdf/cyrillic
%{_datadir}/xpdf/latin2

%{_bindir}/pdfdetach
%{_mandir}/man1/pdfdetach.1.gz

%changelog
*Tue Mar 30 2010 Jarek Sedlacek <jarek@nbcs.rutgers.edu> - 3.02pl4-1
-Centos Build
